const React = {
    createElement
};

function createElement(tag, attr, ...children) {
    return {
        attributes: attr,
        children: children,
        key: undefined,
        nodeName: tag
    };
}

const ReactDOM = {
    render(vdom, container){
        container.innerHTML = "";
        render(vdom, container)
    }
};

function render(vdom, container){
    if(typeof(vdom) === 'string')  {
        container.innerText = vdom;
        return;
    }

    const dom = document.createElement(vdom.nodeName);
    for(let attr in vdom.attributes){
        setAttribute(dom, attr, vdom.attributes[attr]);
    }

    vdom.children.forEach(child=>render(child, dom));
    container.appendChild(dom);
}

function setAttribute(dom, attr, value){
    if(attr == "className") attr = "class"
    if(attr.indexOf('on') == 0) {
        const type = attr.toLowCase().splice(1);
        dom.addEventListener(type, value);
    }else if(attr == 'style'){
        let style="";
        for(let name in value){
        style += name +":" +value[name]+";"
        }
        dom.setAttribute("style", style)
    }else{
        dom.setAttribute(attr, value);
    }
}

//////////////////////////////////////////////////////////////////////
const element = (
    <div className="title">
        hello<span className="content">world!</span>
    </div>
)

//console.log(element);

ReactDOM.render(element, document.body);
